//	ATtiny2313
//	LCDp	J_[tv
//	
//	EJ_[F^ɑΉ
//	EvF12^24ԐɑΉ
//	E\[h^ݒ胂[h
//	
//	LCD Clock typeP
//	PWMPFRgXgƃobNCgPWMŐ
//	PCPFUSB-COMjbgƃVAʐMAPC玞킹Ȃǂ𐧌

/*
	|[gΉ	[ATtiny2313]	x:݂Ȃ -:
	bit		7	6	5	4	3	2	1	0
	portA	x	x	x	x	x	x	-	-		PA2RESETȂ̂ő݂Ȃ̂Ƃ
	portB	LCD	LCD	LCD	LCD	-	PWM	LCD	LCD		LCDڑAPWM(OC0A)
	portD	x	-	PWM	-	swL	swR	TXD	RXD		PWM(OC0B)AXCb`AVAʐM
	
	rh
	WinAVR-20080610		œKIvV:-Os
	ATtiny2313	1MHz
	
	
	LCD Clock ()
	2009/07/27	v0.01	JJn
	2009/07/30	v1.00	
							Program:    1780 bytes (86.9% Full)
							Data:          6 bytes (4.7% Full)
	2009/07/31	v1.10	
							Program:    1668 bytes (81.4% Full)
							Data:         14 bytes (10.9% Full)
	-----------------
	LCD Clock typeP
	2009/08/07	v0.01	typeP JJn
	2009/08/10	v0.02	Program:    1966 bytes (96.0% Full)
						Data:         15 bytes (11.7% Full)
						ȉ̉
						EVAʐM
						ERgXgAobNCgPWM
						Elcdlib.cύXBlcdPutUInt(), lcdPutInt()gȂ悤ɂăR[hTCY啝팸
						E\[hiAԐj̊蓖ĂύX
						Ej̒liʓIȒlցjύXB[0:`6:][0:`6:y]	font5x8.hC
						ElcpCmd.hǉ
	2009/08/12	v0.03	Program:    1946 bytes (95.0% Full)
						Data:         15 bytes (11.7% Full)
						ȉ̉
						E`~R}hǉ
						EtHgEEP-ROM֊i[
*/


#include	<avr/io.h>
#include	<avr/interrupt.h>
#include	<avr/pgmspace.h>
#include	<avr/eeprom.h>
#include	"lcdlib.h"
#include	"font5x8.h"
#include	"lcpCmd.h"


//샂[h
enum	E_OPMODE
{
	OP_CLOCK,		//v\
	OP_ADJ_SEC,		//b
	OP_ADJ_MIN,		//
	OP_ADJ_HOUR,	//
	OP_ADJ_YEAR_10,	//Ni\̈ʁj
	OP_ADJ_YEAR_1,	//Nïʁj
	OP_ADJ_MONTH,	//
	OP_ADJ_DAY,		//
	OP_ADJ_WEEK,	//j
	OP_ADJ_CONTRAST,	//RgXg
	OP_ADJ_BACKLIGHT	//obNCg
};

//̍ŏIi邤N͍lȂj
const	prog_uint8_t	LAST_DAY[]	= { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

//\[h
//bit1:	0	0	1	1	c 0:		1:
//bit0:	0	1	0	1	c 0:24Ԑ	1:12Ԑ
//	l	0	1	2	3
#define	DISPMODE_HOUR12	0x01
#define	DISPMODE_GENGOU	0x02

//`XVv̓e
#define	UPDT_DATE	0x01
#define	UPDT_TIME	0x02

//LCDł̕\ʒu
//		0123456789ABCDEF
//date	2000Y00M00D(W)
//time	A00:00:00
#define	POS_DATE_X	0
#define	POS_DATE_Y	0
#define	POS_TIME_X	0
#define	POS_TIME_Y	1
#define	POS_ADJ_YY	(POS_DATE_X + 2)
#define	POS_ADJ_YY1	(POS_ADJ_YY + 1)
#define	POS_ADJ_MM	(POS_ADJ_YY1 + 3)
#define	POS_ADJ_DD	(POS_ADJ_MM + 3)
#define	POS_ADJ_WK	(POS_ADJ_DD + 3)
#define	POS_ADJ_H	(POS_TIME_X + 2)
#define	POS_ADJ_M	(POS_ADJ_H + 3)
#define	POS_ADJ_S	(POS_ADJ_M + 3)
#define	POS_ADJ_CON	(POS_ADJ_S + 1)
#define	POS_ADJ_BKL	(POS_ADJ_CON + 1)

//ݒ蒆̈ē
#define	ADJ_INFO	"Adj."
#define	POS_INFO_X	12	//16 - sizeof(ADJ_INFO)
#define	POS_INFO_Y	1

//ݒ蒆PWMl̕\ʒu
#define	POS_PWM_X	14	//16 - 2

//LCD[U[`iLN^R[hj
enum	E_LCD_GAIJI
{
	LCD_GAIJI_YEAR	= 0x00,
	LCD_GAIJI_MONTH,
	LCD_GAIJI_DAY,
	LCD_GAIJI_WEEK,
	LCD_GAIJI_HEI,
	LCD_GAIJI_SEI,
	LCD_GAIJI_AM,
	LCD_GAIJI_PM
};

//----------------------------------------------------------------------
//	lcdlib.cg֐A}N
//----------------------------------------------------------------------

static	uint8_t	data[8] = {0};

//lcdDefChar()EEP-ROM̈Ή
void	lcdDefCharP(uint8_t id, uint8_t eidx)
{
	uint8_t	i, size = sizeof(data) / sizeof(data[0]);
	for (i = 0; i < size; i++)
	{
		eeprom_busy_wait();
		data[i] = eeprom_read_byte(eidx * size + i);
	}
	lcdDefChar(id, data);
}

//ݒ胂[hւ̈ڍsAA
#define	lcdAdjModeOn()	lcdCmd(LCD_CMD_DISPLAY_MODE | LCD_SUBCMD_SET_DISPLAY | LCD_SUBCMD_SET_CURSOR)
#define	lcdAdjModeOff()	lcdCmd(LCD_CMD_DISPLAY_MODE | LCD_SUBCMD_SET_DISPLAY)

//1̕Ȃ
#define	lcdPutInt1(n)	lcdPutChar('0' + (n))

//2̕Ȃ
void	lcdPutInt2(uint8_t n, uint8_t pad)
{
	if (n < 10)
	{
		lcdPutChar(pad);
		lcdPutInt1(n);
	}
	else
	{
		lcdPutInt1(n / 10);
		lcdPutInt1(n % 10);
	}
}

//0l2̕Ȃ
void	lcdPutInt02(uint8_t n)
{
	lcdPutInt2(n, '0');
}

//󔒋l2̕Ȃ
void	lcdPutIntSP2(uint8_t n)
{
	lcdPutInt2(n, ' ');
}

//0l216i
const	prog_uint8_t	HEX_CHAR[] = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F' };
void	lcdPutHex02(uint8_t	n)
{
	lcdPutChar(pgm_read_byte(&HEX_CHAR[(n >> 4) & 0x0F]));
	lcdPutChar(pgm_read_byte(&HEX_CHAR[n & 0x0F]));
}

//----------------------------------------------------------------------

//t\iNj
void	displayDateYear(uint8_t year, uint8_t dispMode)
{
	if (dispMode & DISPMODE_GENGOU)
	{
		lcdPutChar(LCD_GAIJI_HEI);
		lcdPutChar(LCD_GAIJI_SEI);
		lcdPutInt02(year + 12);
	}
	else
	{
		lcdPutInt02(20);
		lcdPutInt02(year);
	}
}

//t\
void	displayDate(uint8_t year, uint8_t dispMode, uint8_t month, uint8_t day, uint8_t week)
{
	displayDateYear(year, dispMode);
	lcdPutChar(LCD_GAIJI_YEAR);
	
	lcdPutIntSP2(month);
	lcdPutChar(LCD_GAIJI_MONTH);
	
	lcdPutIntSP2(day);
	lcdPutChar(LCD_GAIJI_DAY);
	
	lcdPutChar('(');
	lcdPutChar(LCD_GAIJI_WEEK);
	lcdPutChar(')');
}

//\ij
void	displayTimeHour(uint8_t ampm, uint8_t hour)
{
	lcdPutChar(ampm);
	lcdPutIntSP2(hour);
}

//\
void	displayTime(uint8_t ampm, uint8_t hour, uint8_t min, uint8_t sec)
{
	displayTimeHour(ampm, hour);
	lcdPutChar(':');
	
	lcdPutInt02(min);
	lcdPutChar(':');
	
	lcdPutInt02(sec);
}

//PWM
//RgXg̍ől
#define	PWM_CON_MAX		0x80	//0x80𒴂ƕ\ČȂȂ

//VAʐM
//Mobt@̋󂫑҂
#define sendReady()		while (!(UCSRA & (1 << UDRE)))


//荞ݔʒmtOiWX^R2Ɋtj
volatile	register	uint8_t	bTC	asm("r2");

//16bit^C}	1(sec)Ƃ̌Ăяo
ISR(TIMER1_COMPA_vect)
{
	bTC = 1;
}


int	main(void)
{
	uint8_t	year, month, day, week;		//2AAAji0-67jj
	uint8_t	hour24, hour, min, sec;		//i24ԁjAi\pjAb
	uint8_t	ampm;						//ߑO^ߌ
	uint8_t	opMode, dispMode;			//샂[hA\[h
	uint8_t	doUpdate;		//`XVtO
	uint8_t	sw, psw;		//XCb`ǂݎ
	uint8_t	swOn[2];		//XCb`̏Ԃi[z	1:on	0:off
	uint8_t	loopCnt;		//^C~O҂ȂǂɎgJE^
	uint8_t	pwmCon, pwmBkLt;	//PWMFRgXgAobNCg
	uint8_t	didx;			//Mobt@̃CfbNX
	uint8_t	drawStop;		//`~tO
	
	year = 0;
	month = day = 1;
	week = 0;
	hour24 = hour = min = sec = 0;
	ampm = ' ';
	opMode = OP_CLOCK;
	dispMode = 0;
	doUpdate = UPDT_DATE | UPDT_TIME;
	psw = sw = 0;
	loopCnt = 0;
	pwmCon = 0x20;
	pwmBkLt = 0x80;
	didx = 0;
	drawStop = 0;
	
	//|[gݒ
	DDRB	= 0b00000100;	//PWMo PB2(OC0A:RgXg)
	DDRD	= 0b00100000;	//PWMo PD5(OC0B:obNCg)
	PORTD	= 0b00001100;	//XCb`2	PD3-PD2
	
	//LCD
	lcdInit();
	
	//LCD[U[`o^
	lcdDefCharP(LCD_GAIJI_YEAR,	E_YEAR);
	lcdDefCharP(LCD_GAIJI_MONTH,	E_MON);
	lcdDefCharP(LCD_GAIJI_DAY,	E_SUN);
	lcdDefCharP(LCD_GAIJI_WEEK,	E_SUN);
	lcdDefCharP(LCD_GAIJI_HEI,	E_HEI);
	lcdDefCharP(LCD_GAIJI_SEI,	E_SEI);
	lcdDefCharP(LCD_GAIJI_AM,	E_AM);
	lcdDefCharP(LCD_GAIJI_PM,	E_PM);
	
	//VAʐM
	//1MHz 4800bps -> N=12(.0) -> 4807.7 (0.16%)
	//UMSEL=0:񓯊, UPM1/0=00:peBȂ, USBS=0:Xgbvrbg1, UCSRB:UCSZ2-UCSRC:UCSZ1/0=011:f[^8rbg
	UBRRH	= 0;
	UBRRL	= 12;
	UCSRB	= (1 << RXEN) | (1 << TXEN) | (0 << UCSZ2);		//RXD(PD0),TXD(PD1)Lɂ
	UCSRC	= (0 << UMSEL) | (0 << UPM1) | (0 << UPM0) | (0 << USBS) | (1 << UCSZ1) | (1 << UCSZ0);
	
	//8bit^C}[
	//8rbgPWM	TCCR0B:WGM02=0, TCCR0A:WGM01=1, TCCR0A:WGM00=1
	//rAo	񔽓]	TCCR0A:COM0A1=1, TCCR0A:COM0A0=0
	//rBo	񔽓]	TCCR0A:COM0B1=1, TCCR0A:COM0B0=0
	//(Ȃ)		TCCR0B:CS02=0, TCCR0B:CS01=0, TCCR0B:CS00=1
	TCCR0A	= (1 << COM0A1) | (0 << COM0A0) | (1 << COM0B1) | (0 << COM0B0) | (1 << WGM01) | (1 << WGM00);
	TCCR0B	= (0 << WGM02) | (0 << CS02) | (0 << CS01) | (1 << CS00);
	OCR0A = pwmCon;		//rl
	OCR0B = pwmBkLt;	//rl
	
	//16bit^C}[
	//CTC	TCCR1B:WGM12=1, TCCR1A:WGM11=0, TCCR1A:WGM10=0
	//(64)	CS12=0, CS11=1, CS10=1
	TCCR1A	= (0 << WGM11) | (0 << WGM10);
	TCCR1B	= (1 << WGM12) | (0 << CS12) | (1 << CS11) | (1 << CS10);
	OCR1A	= F_CPU / 64 - 1;	//rl	1bviF_CPU=1MHzzj
	
	//荞ݐݒ
	TIMSK	= (1 << OCIE1A);	//16bit^C}[:rv荞
	
	bTC = 0;
	sei();		//荞݋
	
	while (1)
	{
		//荞ݔiԌo߁j
		if (bTC)
		{
			bTC = 0;
			doUpdate |= UPDT_TIME;
			if (++sec >= 60)
			{
				sec = 0;
				if (++min >= 60)
				{
					min = 0;
					if (++hour24 >= 24)		//펞24ԐŃJEgA\iKŉH
					{
						doUpdate |= UPDT_DATE;
						hour24 = 0;
						if (++week >= 7) week = 0;
						lcdDefCharP(LCD_GAIJI_WEEK, E_SUN + week);
						if (++day > pgm_read_byte(&LAST_DAY[month]))
						{
							day = 1;
							if (++month > 12)
							{
								month = 1;
								if (++year >= 100) year = 0;	//year͐̉2
							}
						}
					}
				}
			}
		}
		
		//\XV
		if (drawStop) doUpdate = 0;
		
		if (doUpdate & UPDT_DATE)
		{
			lcdSetPos(POS_DATE_X, POS_DATE_Y);
			displayDate(year, dispMode, month, day, week);
		}
		
		if (doUpdate & UPDT_TIME)
		{
			//nԐ̎\
			//12: 12, 1,..........,12, 1,..,11,12
			//24:  0, 1,..........,12,13,..,23, 0
			hour = hour24;
			if (dispMode & DISPMODE_HOUR12)
			{
				if (hour == 0) hour = 12;
				if (12 < hour) hour -= 12;
				//^Ƃ12:00̏uԂɌߑO^ߌ؂ւ
				ampm = (12 <= hour24) ? LCD_GAIJI_PM : LCD_GAIJI_AM;
			}
			else
			{
				//AM/PM\͋
				ampm = ' ';
			}
			
			lcdSetPos(POS_TIME_X, POS_TIME_Y);
			displayTime(ampm, hour, min, sec);
		}
		
		doUpdate = 0;
		
		//XCb`ǂݎ
		swOn[1] = swOn[0] = 0;
		if ((++loopCnt & 0x20) == 0x20)		//`^OłxɃ[vԊu󂯂
		{
			sw = PIND & 0b00001100;
			if (psw != sw)
			{
				swOn[0] = ~sw & 0b00000100;		//swL
				swOn[1] = ~sw & 0b00001000;		//swR
				psw = sw;
			}
		}
		
		//ʐMɂO̐ݒύX
		if (UCSRA & (1 << RXC))		//VAʐMM
		{
			//Mf[^(1byte)擾
			data[didx++] = UDR;		//data[]lcdDefCharP()ƌp
			
			if ((data[0] & 0x0F) < didx)	//Sf[^M
			{
				didx = 0;
				switch (data[0])
				{
				case CMD_SET_DATE:		//ݒ肷
					year = data[1];		month = data[2];	day = data[3];	week = data[4];
					hour24 = data[5];	min = data[6];		sec = data[7];
					TCNT1 = 0;
					lcdDefCharP(LCD_GAIJI_WEEK, E_SUN + week);	//Medata[]͂Ŕjijj
					doUpdate = UPDT_DATE | UPDT_TIME;
					break;
					
				case CMD_SET_DISPLAY:	//\[hݒ肷
					dispMode = data[1];
					doUpdate = UPDT_DATE | UPDT_TIME;
					break;
					
				case CMD_SET_CON_BKLT:	//RgXgAobNCgݒ肷
					OCR0A = pwmCon = data[1];
					OCR0B = pwmBkLt = data[2];
					//obNCg~i킸ɗdJbgASȐ^Âɂj
					if (pwmBkLt < 0x10)
						TCCR0A	&= ~(1 << COM0B1);
					else
						TCCR0A	|= (1 << COM0B1);
					break;
					
				case CMD_GET_VALUE:		//݂̐ݒli肪j擾
					sendReady();	UDR = dispMode;
					sendReady();	UDR = pwmCon;
					sendReady();	UDR = pwmBkLt;
					break;
					
				case CMD_DRAWSTOP:		//`~iv쎩̂͌pj
					drawStop = data[1];
					break;
					
				//case CMD_BUF_CLEAR:
				default:	//Mobt@ɂ
					while (UCSRA & (1 << RXC)) data[0] = UDR;
					break;
				}
			}
		}
		
		//\eύX
		switch (opMode)
		{
		case OP_ADJ_YEAR_10:
			lcdSetPos(POS_ADJ_YY, POS_DATE_Y);
			//XCb`͔
			if (swOn[0])
			{
				opMode = OP_ADJ_YEAR_1;
			}
			if (swOn[1])
			{
				if (year < 90) year += 10;
				else year %= 10;
				doUpdate = UPDT_DATE;
			}
			break;
			
		case OP_ADJ_YEAR_1:
			lcdSetPos(POS_ADJ_YY1, POS_DATE_Y);
			//XCb`͔
			if (swOn[0])
			{
				opMode = OP_ADJ_MONTH;
			}
			if (swOn[1])
			{
				if (year % 10 < 9) year++;
				else year /= 10;
				doUpdate = UPDT_DATE;
			}
			break;
			
		case OP_ADJ_MONTH:
			lcdSetPos(POS_ADJ_MM, POS_DATE_Y);
			//XCb`͔
			if (swOn[0])
			{
				opMode = OP_ADJ_DAY;
			}
			if (swOn[1])
			{
				if (++month > 12) month = 1;
				doUpdate = UPDT_DATE;
			}
			break;
			
		case OP_ADJ_DAY:
			lcdSetPos(POS_ADJ_DD, POS_DATE_Y);
			//XCb`͔
			if (swOn[0])
			{
				opMode = OP_ADJ_WEEK;
			}
			if (swOn[1])
			{
				if (++day > 31) day = 1;	//ɂ炸31܂Őݒł
				doUpdate = UPDT_DATE;
			}
			break;
			
		case OP_ADJ_WEEK:
			lcdSetPos(POS_ADJ_WK, POS_DATE_Y);
			//XCb`͔
			if (swOn[0])
			{
				opMode = OP_ADJ_HOUR;
			}
			if (swOn[1])
			{
				if (++week >= 7) week = 0;
				lcdDefCharP(LCD_GAIJI_WEEK, E_SUN + week);
				doUpdate = UPDT_DATE;
			}
			break;
			
		case OP_ADJ_HOUR:
			lcdSetPos(POS_ADJ_H, POS_TIME_Y);
			//XCb`͔
			if (swOn[0])
			{
				opMode = OP_ADJ_MIN;
			}
			if (swOn[1])
			{
				if (++hour24 >= 24) hour24 = 0;
				doUpdate = UPDT_TIME;
			}
			break;
			
		case OP_ADJ_MIN:
			lcdSetPos(POS_ADJ_M, POS_TIME_Y);
			//XCb`͔
			if (swOn[0])
			{
				opMode = OP_ADJ_SEC;
			}
			if (swOn[1])
			{
				if (++min >= 60) min = 0;
				doUpdate = UPDT_TIME;
			}
			break;
			
		case OP_ADJ_SEC:
			lcdSetPos(POS_ADJ_S, POS_TIME_Y);
			//XCb`͔
			if (swOn[0])
			{
				opMode = OP_ADJ_CONTRAST;
				lcdSetPos(0x0E, POS_DATE_Y);
				lcdPutHex02(pwmCon);
			}
			if (swOn[1])
			{
				sec = 0;
				TCNT1 = 0;
				doUpdate = UPDT_TIME;
			}
			break;
			
		case OP_ADJ_CONTRAST:
			lcdSetPos(POS_ADJ_CON, POS_TIME_Y);
			//XCb`͔
			if (swOn[0])
			{
				opMode = OP_ADJ_BACKLIGHT;
				lcdSetPos(0x0E, POS_DATE_Y);
				lcdPutHex02(pwmBkLt);
			}
			if (swOn[1])
			{
				pwmCon += 0x10;
				if (PWM_CON_MAX < pwmCon) pwmCon = 0;
				OCR0A = pwmCon;
				
				//݂̐ݒl\
				lcdSetPos(POS_PWM_X, POS_DATE_Y);
				lcdPutHex02(pwmCon);
			}
			break;
			
		case OP_ADJ_BACKLIGHT:
			lcdSetPos(POS_ADJ_BKL, POS_TIME_Y);
			//XCb`͔
			if (swOn[0])
			{
				//\[h֕A
				opMode = OP_CLOCK;
				lcdAdjModeOff();
				lcdCls();
				doUpdate = UPDT_DATE | UPDT_TIME;
			}
			if (swOn[1])
			{
				if (pwmBkLt == 0xF0) pwmBkLt = 0xFF;
				else pwmBkLt += 0x10;
				if (pwmBkLt < 0x10) pwmBkLt = 0;
				OCR0B = pwmBkLt;
				
				//݂̐ݒl\
				lcdSetPos(POS_PWM_X, POS_DATE_Y);
				lcdPutHex02(pwmBkLt);
			}
			break;
			
		//case OP_CLOCK:
		default:
			//XCb`͔
			if (swOn[0])
			{
				//ݒ胂[hp̓\ɕύX
				dispMode = 0;	//A24Ԑ
				doUpdate = UPDT_DATE | UPDT_TIME;
				
				//̑̒ڂ\
				lcdSetPos(POS_ADJ_CON, POS_TIME_Y);
				lcdPutChar('C');
				lcdPutChar('B');
				
				//ݒ胂[hֈڍs
				opMode = OP_ADJ_YEAR_10;
				lcdAdjModeOn();
				lcdSetPos(POS_INFO_X, POS_INFO_Y);
				lcdPutStr((uint8_t*)ADJ_INFO);
			}
			if (swOn[1])
			{
				//\[hύX
				if (++dispMode > 3) dispMode = 0;
				doUpdate = UPDT_DATE | UPDT_TIME;
			}
			break;
			
		}	//switch()

	}	//while()
	
	return 0;
}
